      subroutine hetk8s
     & (ncl, jview, nzs, ths, thv, phi,  aas, aav, 
     & psgvu, bdgfu, bdgfd, btr1u, btr1d)
c
c     Gap probabilities               A. Kuusk   1.12.2000
c     Modified for elliptical LAD 3.12.2012
c
c  Input:
c    lelli, ncl, shl, nzs, nsangl, thknot, phi,
c    stdns, htr, hc1, hc2, rcr, dbh, glmp, uuu,
c  Output:
c    aas, aav, psgvu, bdgfu, bdgfd, btr1u, btr1d
c
      include 'par.h'
      include 'stands.h'
c
      save x1, y1, z1, x2, y2, z2
c
      dimension bdgfu(nclmax), bdgfd(nclmax)
      dimension btr1u(nclmax), btr1d(nclmax)
      dimension aav(nvwmax)
c
      data x1, y1, z1, x2, y2, z2, x3, y3, z3 /9*0.d0/
c
      rlls1 = 0.d0
      rllv1 = 0.d0
      rllv3 = 0.d0
c
      sths = sin(ths)
      cths = cos(ths)
      sthv = sin(thv)
      cthv = cos(thv)
c                 The gap probability in view direction aav on ground
      chs1 = 0.d0
      chs3 = 0.d0
      z0x  = 0.d0
      thx  = thv
      call aazvuv 
     & (ncl, z0x, thx, aavx)
      aav(jview) = aavx
c                 The gap probability in sun direction  aas on ground
      thx = ths
      call aazvus
     & (ncl, z0x, thx, aax)
       aas = aax
c
      sphi  = sin(phi)
      cphi  = cos(phi)
      calph = sthv*sths*cphi + cthv*cths
      call spooj
     & (ncl, x1, y1, z1, x2, y2, z2, x3, y3, z3,
     & rlls1, rllv1, rllv3, sths, cths, sthv, cthv,
     & sphi, cphi, calph, chs1, chs3, poou, pood)
      psgvu = poou
c
      do jcl = 1, ncl
        call enel
     & (ncl, jcl, ths, thv, phi, nzs, 
     & bdgfu, bdgfd, btr1u, btr1d)
      enddo
c
      return
      end
*
************************************************************************
*
