      subroutine crprojd
     & (lellj, tgthv, zx, htrj, hc1j, hc2j, rcrj, szuj, vzuj)
c
c  Crown projection in view direction thv, A. Kuusk, 29.06.2021
c
c  Input:
c    zx, tgthv=tan(thv), tree parameters htrj, hc1j, hc2j, rcrj
c  Output:
c    szuj - crown projection, vzuj - crown volume above the level zx
c
      include 'par.h'
c
*     logical lellj
c
      if (lellj) then
        cellj = hc1j*0.5d0
        call  pi11d (tgthv, zx, htrj, cellj, rcrj, szuj, vzuj)
      else 
        call  pi22d
     &               (tgthv, zx, htrj, hc1j, hc2j, rcrj, szuj, vzuj)
      endif
c
      return
      end
*
************************************************************************
*
